/*-----------------------------------------------------------------------*
  Project:  Nintendo Augmented Reality Library.
  File:     narDebug.h

  Copyright (C)2011-2012 Nintendo Co., Ltd.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensed developers
  and are protected by national and international copyright laws. They
  may not be disclosed to third parties or copied or duplicated in any
  form, in whole or in part, without the prior written consent of
  Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
*-----------------------------------------------------------------------*/

/* Please see man pages for details 
 
 
 */

#ifndef NAR_DEBUG_H__
#define NAR_DEBUG_H__

#include "narPort.h"
#include "narFlags.h"

namespace mw { namespace nar
{
    /* Please see man pages for details 
     */
    class Debug_cl
    {
    public:
        /* Please see man pages for details 
         */
        enum Switch_e
        {
            me_ViewNone,
            /// Flag needed to clear
            NAR_EFLAG( me_ViewClear ),
            /// Render outline candidate
            NAR_EFLAG( me_ViewLineCandidates ),
            /// Render mesh for marker determination
            NAR_EFLAG( me_ViewCheckMesh ),
            /// Render straight line slope
            NAR_EFLAG( me_ViewEdgeSlope ),
            /// Render least-square sample
            NAR_EFLAG( me_ViewSample ),
            me_ViewLastFlag,
            me_ViewInfo = static_cast< s32 >( me_ViewLastFlag ) - 1,
            me_SwitchEnd
        };

        /* Please see man pages for details 
         */
        static Flags_tc< u8, Switch_e > & GetrSwitch() { return instance().m_Flags; }
    private:
        Flags_tc< u8, Switch_e >    m_Flags;

        static Debug_cl & instance()
        {
            static Debug_cl debug;
            return debug;
        }
    };
}
}


#endif
