/*-----------------------------------------------------------------------*
  Project:  Nintendo Augmented Reality Library.
  File:     narMarkerDatabase.h

  Copyright (C)2011-2012 Nintendo Co., Ltd.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensed developers
  and are protected by national and international copyright laws. They
  may not be disclosed to third parties or copied or duplicated in any
  form, in whole or in part, without the prior written consent of
  Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
*-----------------------------------------------------------------------*/

/* Please see man pages for details 
 
 
 */
#ifndef NAR_MARKER_DATABASE_H__
#define NAR_MARKER_DATABASE_H__

#include "narConfig.h"
#include "narMarkerTemplate.h"

namespace mw { namespace nar
{
    class MarkerPattern_st;

    /* Please see man pages for details 
     
     */
    class MarkerDatabase_cl
    {
    public:
        /* Please see man pages for details 
         
         
         
         */
        MarkerDatabase_cl( f32 th = 0.5f )
             : m_TemplateNum( 0 ), m_Threshold( th ), mp_Template( 0 )
        {
        }

        /* Please see man pages for details 
         
         
         */
        bool Register( MarkerTemplate_st & r_Template );

        /* Please see man pages for details 
         
         
         
         */
        bool Unregister( MarkerTemplate_st & r_Template );

        /* Please see man pages for details 
         
         */
        void UnregisterAll()
        {
            m_TemplateNum 	= 0;
            mp_Template		= 0;
        }

        /* Please see man pages for details 
         
         */
        bool IsRegistered( const MarkerTemplate_st & cr_Template );

        /* Please see man pages for details 
         
         */
        void SetThreshold( f32 th ){ m_Threshold = th; }

        /* Please see man pages for details 
         
         */
        f32 GetThreshold() const { return m_Threshold; }

        //
        /* Please see man pages for details 
         */
        const MarkerTemplate_st * Find( s32 * p_Dir, f32 * p_Score, const MarkerPattern_st & cr_Pattern );
        //
    private:
        u32                     m_TemplateNum;
        /// Threshold for determining whether something is a marker
        f32                     m_Threshold;
        MarkerTemplate_st *     mp_Template;
    };
}
}

#endif
