/*-----------------------------------------------------------------------*
  Project:  Nintendo Augmented Reality Library.
  File:     narMarkerTemplate.h

  Copyright (C)2011-2012 Nintendo Co., Ltd.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensed developers
  and are protected by national and international copyright laws. They
  may not be disclosed to third parties or copied or duplicated in any
  form, in whole or in part, without the prior written consent of
  Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
*-----------------------------------------------------------------------*/

/* Please see man pages for details 
 
 
 */
#ifndef NAR_MARKER_TEMPLATE_H__
#define NAR_MARKER_TEMPLATE_H__

#include "narVec2.h"
#include "narMarkerPattern.h"

namespace mw { namespace nar
{
    enum
    {
        e_MarkerDir_Top = 0,
        e_MarkerDir_Left,
        e_MarkerDir_Bottom,
        e_MarkerDir_Right,
        e_MarkerDirNum
    };

    /* Please see man pages for details 
     */
    struct MarkerTemplate_st
    {
        /// Marker ID returned when detected (cannot be specified when negative)
        s32                     id;
        /// Aspect ratio of marker frame (W/H)
        f32                     aspectRatio;
        /// Marker height in the world coordinate system
        f32                     sideLength;
        /// Image pattern data for inside the marker
        MarkerPattern_st        pattern;
        /// Pointer to the next template.
        MarkerTemplate_st *     p_Next;
    };
}
}

#endif
