/*-----------------------------------------------------------------------*
  Project:  Nintendo Augmented Reality Library.
  File:     narMath.h

  Copyright (C)2011-2012 Nintendo Co., Ltd.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensed developers
  and are protected by national and international copyright laws. They
  may not be disclosed to third parties or copied or duplicated in any
  form, in whole or in part, without the prior written consent of
  Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
*-----------------------------------------------------------------------*/

//
/* Please see man pages for details 
 
 
 */

#ifndef NAR_MATH_H__
#define NAR_MATH_H__

#include <math.h>

#include "narConfig.h"

#ifdef NAR_CTR__
#include <nn/math.h>
#endif

namespace mw { namespace nar
{
    //=====================================================================
    /* Please see man pages for details 
     
     */
    inline f32 Sqrt( f32 x )
    {
        return ::std::sqrtf( x );
    }
    //=====================================================================
    /* Please see man pages for details 
     
     */
    inline f32 Cbrt( f32 x )
    {
#ifdef NAR_CTR__
        return nn::math::FCbrt( x );
#endif
    }
    //=====================================================================
    /* Please see man pages for details 
     
     */
    inline f32 Sin( f32 rad )
    {
#ifdef NAR_CTR__
        return nn::math::SinRad( rad );
#endif
    }
    //=====================================================================
    /* Please see man pages for details 
     
     */
    inline f32 Cos( f32 rad )
    {
#ifdef NAR_CTR__
        return nn::math::CosRad( rad );
#endif
    }
    //=====================================================================
    /* Please see man pages for details 
     
     */
    inline f32 ACos( f32 x )
    {
        return ::std::acos( x );
    }
    //=====================================================================
    /* Please see man pages for details 
     
     */
    template < typename T >
    inline T Pow2( T x )
    {
        return x * x;
    }
    //=====================================================================
    /* Please see man pages for details 
     
     */
    template < typename T >
    inline T Pow3( T x )
    {
        return x * x * x;
    }

    //=====================================================================
    /* Please see man pages for details 
     
     */
    inline int Abs( int x )
    {
        return x < 0 ? -x : x;
    }
    inline f32 Abs( f32 x )
    {
        return ::std::fabsf( x );
    }
    //=====================================================================
    /* Please see man pages for details 
     
     */
    template < typename T >
    inline T Max( T a, T b )
    {
        return a > b ? a : b;
    }
    //=====================================================================
    /* Please see man pages for details 
     
     */
    template < typename T >
    inline T Min( T a, T b )
    {
        return a < b ? a : b;
    }
    //=====================================================================
    /*  

*/
    extern const f32 c_Epsilon;
    extern const f32 c_NearThreshold;
}
}
#endif
//
