/*-----------------------------------------------------------------------*
  Project:  Nintendo Augmented Reality Library.
  File:     narEdgeLine.h

  Copyright (C)2011-2012 Nintendo Co., Ltd.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensed developers
  and are protected by national and international copyright laws. They
  may not be disclosed to third parties or copied or duplicated in any
  form, in whole or in part, without the prior written consent of
  Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
*-----------------------------------------------------------------------*/

//
/* Please see man pages for details 
 
 
 */
#ifndef NAR_MESH_LINE_H__
#define NAR_MESH_LINE_H__

#include "narVec2.h"

namespace mw { namespace nar
{
    /* Please see man pages for details 
     
     */
    class MeshLine_cl
    {
    public:
        MeshLine_cl()
        {
        }

        /* Please see man pages for details 
         */
        void SetStart( f32 x, f32 y )
        {
            m_Start.Set( x, y );
        }

        /* Please see man pages for details 
         */
        void SetStart( const Vec2F_st & cr )
        {
            SetStart( cr.X(), cr.Y() );
        }

        /* Please see man pages for details 
         */
        void SetEnd( f32 x, f32 y )
        {
            m_End.Set( x, y );
        }

        /* Please see man pages for details 
         */
        void SetEnd( const Vec2F_st & cr )
        {
            SetEnd( cr.X(), cr.Y() );
        }

        /* Please see man pages for details 
         */
        bool GetIntersection( Vec2F_st * p_Point, const MeshLine_cl & r_Edge ) const;
        
        f32   GetA() const { return m_A; }
        f32   GetB() const { return m_B; }
        f32   GetC() const { return m_C; }

        /* Please see man pages for details 
         */
        s32  GetSquareLength() const
        {
            return GetrStart().GetSquareDistance( GetrEnd() );
        }

        /* Please see man pages for details 
         */
        bool CalcEquation();

        /* Please see man pages for details 
         
         */
        f32 GetDistance( const Vec2F_st &r ) const;

        /* Please see man pages for details 
         
         */
        f32 GetDistance( const Vec2I_st &r ) const;

    private:
        /// a from straight-line equation:  ax + by + c = 0
        f32         m_A;
        /// b from straight-line equation:  ax + by + c = 0
        f32         m_B;
        /// c from straight-line equation:  ax + by + c = 0
        f32         m_C;

        Vec2F_st    m_Start;
        Vec2F_st    m_End;

        const Vec2F_st & GetrStart() const { return m_Start; }
        const Vec2F_st & GetrEnd()  const { return m_End; }
    };
}
}
#endif
//
