/*-----------------------------------------------------------------------*
  Project:  Nintendo Augmented Reality Library.
  File:     narPlane.h

  Copyright (C)2011-2012 Nintendo Co., Ltd.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensed developers
  and are protected by national and international copyright laws. They
  may not be disclosed to third parties or copied or duplicated in any
  form, in whole or in part, without the prior written consent of
  Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
*-----------------------------------------------------------------------*/

//
/* Please see man pages for details 
 
 
 */
#ifndef NAR_PLANE_H__
#define NAR_PLANE_H__

#include "narVec3.h"

namespace mw { namespace nar
{
    /* Please see man pages for details 
     
     */
    class Plane_cl
    {
    public:
        /* Please see man pages for details 
         
         */
        Plane_cl( const Vec3F_st & r_Normal, const Vec3F_st & r_Point )
        {
            ma_Data[ me_A ] = r_Normal.X();
            ma_Data[ me_B ] = r_Normal.Y();
            ma_Data[ me_C ] = r_Normal.Z();
            ma_Data[ me_D ] = - r_Normal.X() * r_Point.X() - r_Normal.Y() * r_Point.Y() - r_Normal.Z() * r_Point.Z();
        }

        f32 GetA() const { return ma_Data[ me_A ]; }
        f32 GetB() const { return ma_Data[ me_B ]; }
        f32 GetC() const { return ma_Data[ me_C ]; }
        f32 GetD() const { return ma_Data[ me_D ]; }

        
        /* Please see man pages for details 
         
         
         */
        void GetIntersection( Vec3F_st & r_Inter, const Vec3F_st & cr_Vec ) const
        {
            // Calculate straight-line parameter t
            f32 m = GetA() * cr_Vec.X() + GetB() * cr_Vec.Y() + GetC() * cr_Vec.Z();
            f32 t = - GetD() / m;
            r_Inter = cr_Vec;
            r_Inter.Scale( t );
        }
    private:
        enum
        {
            me_A, me_B, me_C, me_D, me_Max
        };
        f32 ma_Data[ me_Max ];
    };
}
}
#endif
//
