/*-----------------------------------------------------------------------*
  Project:  Nintendo Augmented Reality Library.
  File:     narPort.h

  Copyright (C)2011-2012 Nintendo Co., Ltd.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensed developers
  and are protected by national and international copyright laws. They
  may not be disclosed to third parties or copied or duplicated in any
  form, in whole or in part, without the prior written consent of
  Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
*-----------------------------------------------------------------------*/

//
/* Please see man pages for details 
 
 
 
 */
#ifndef NAR_PORT_H__
#define NAR_PORT_H__

#include "narConfig.h"

//
//  CTR
//
#ifdef NAR_CTR__
#include <nn/types.h>
#endif

namespace mw { namespace nar
{
    //=====================================================================
    /* Please see man pages for details 
     
     */
    void ClearFast( void * p_Dest, u32 size );
    //=====================================================================
    /* Please see man pages for details 
     
     */
    void Clear( void * p_Dest, u32 size );
    //=====================================================================
    /* Please see man pages for details 
     
     */
#ifdef NAR_CTR__
#if NAR_DEBUG__
#   define  NAR_PRINTF( ... )   (void)nn::dbg::detail::Printf( __VA_ARGS__)
#else
#   define  NAR_PRINTF( ... )   
#endif
#endif
    //=====================================================================
    /* Please see man pages for details 
     
     */
#ifdef NAR_CTR__
#if NAR_DEBUG__
#   define  NAR_TPRINTF( ... )  (void)nn::dbg::detail::TPrintf( __VA_ARGS__)
#else
#   define  NAR_TPRINTF( ... )  
#endif
#endif
    //=====================================================================
    /* Please see man pages for details 
     
     */
#ifdef NAR_CTR__
#	define	NAR_NULL_TASSERT( exp )		NN_NULL_TASSERT_( exp )
#   define  NAR_TASSERT( exp )    		NN_TASSERT( exp )
#	define	NAR_MIN_TASSERT( exp, min )	NN_MIN_TASSERT_( exp, min )
#   define  NAR_ASSERT_MSG( exp, ... )  NN_ASSERTMSG( exp, __VA_ARGS__)
#endif // NAR_CTR__

}
}

#ifdef NAR_TWL__
#   define NAR_RGB5A1_R_SHIFT            (0)
#   define NAR_RGB5A1_G_SHIFT            (5)
#   define NAR_RGB5A1_B_SHIFT            (10)
#   define NAR_RGB5A1_A_SHIFT            (15)
#endif

#ifdef NAR_CTR__
#   define NAR_RGB5A1_R_SHIFT            (11)
#   define NAR_RGB5A1_G_SHIFT            (6)
#   define NAR_RGB5A1_B_SHIFT            (1)
#   define NAR_RGB5A1_A_SHIFT            (0)
#endif

#define NAR_RGB5A1( r, g, b, a )        ((u16)((((r)&0x1f) << NAR_RGB5A1_R_SHIFT) | \
                                               (((g)&0x1f) << NAR_RGB5A1_G_SHIFT) | \
                                               (((b)&0x1f) << NAR_RGB5A1_B_SHIFT) | \
                                               (((a)&0x1) << NAR_RGB5A1_A_SHIFT)))

#define NAR_DEC_TO_FX32( x )    FX_F32_TO_FX32( x )

#endif

//
