/*-----------------------------------------------------------------------*
  Project:  Nintendo Augmented Reality Library.
  File:     narProjection.h

  Copyright (C)2011-2012 Nintendo Co., Ltd.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensed developers
  and are protected by national and international copyright laws. They
  may not be disclosed to third parties or copied or duplicated in any
  form, in whole or in part, without the prior written consent of
  Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
*-----------------------------------------------------------------------*/

/* Please see man pages for details 
 
 
 */

#ifndef NAR_PROJECTION_H__
#define NAR_PROJECTION_H__

#include "narPort.h"

#ifdef NAR_CTR__
namespace nn {
    namespace math {
        struct MTX44;
    }
}
#endif

namespace mw { namespace nar
{
    struct Vec2F_st ;
    struct Vec3F_st ;
    class Distortion_cl;
    /* Please see man pages for details 
     */
    class Projection_cl
    {
    public:
        Projection_cl()
        {}

        /* Please see man pages for details 
         
         
         
         
         
         */
        Projection_cl( f32 w, f32 h, f32 near, f32 far, f32 aov = 66.0 )
        {
            Set( w, h, near, far, aov );
        }

        /* Please see man pages for details 
         
         
         
         
         
         */
        void Set( f32 w, f32 h, f32 near, f32 far, f32 aov = 66.0 );
#ifdef NAR_TWL__
        /* Please see man pages for details 
         */
        void GetMtxFx44( MtxFx44 & r_Mtx ) const ;
#endif
#ifdef NAR_CTR__
        /* Please see man pages for details 
         */
        void GetMTX44( nn::math::MTX44 & r_Mtx ) const;

        /* Please see man pages for details 
         
         
         
         
         
         */
        void GetTrimmed( nn::math::MTX44 & r_Mtx, f32 l, f32 r, f32 b, f32 t, f32 n, f32 f, f32 aov = 66.f ) const;
#endif
        //
        
        /* Please see man pages for details 
         
         
         */
        void GetVtxOnReferencePlane( Vec3F_st & r_Vec3, const Vec2F_st & r_Vec2 ) const;

        /* Please see man pages for details 
         
         
         
         */
        void GetVtxOnReferencePlane( Vec3F_st & r_Vec3, const Vec2F_st & cr_Vec2, const Distortion_cl & cr_Dist ) const;
        //
    private:
        f32     m_00;
        f32     m_11;
        f32     m_22;
        f32     m_32;
        f32     m_HalfWidth;
        f32     m_HalfHeight;
    };
}
}

#endif
