/*-----------------------------------------------------------------------*
  Project:  Nintendo Augmented Reality Library.
  File:     narTransformation.h

  Copyright (C)2011-2012 Nintendo Co., Ltd.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensed developers
  and are protected by national and international copyright laws. They
  may not be disclosed to third parties or copied or duplicated in any
  form, in whole or in part, without the prior written consent of
  Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
*-----------------------------------------------------------------------*/

/* Please see man pages for details 
 
 
 */
#ifndef NAR_TRANSFORMATION_H__
#define NAR_TRANSFORMATION_H__

#include "narVec3.h"

#ifdef NAR_CTR__
namespace nn {
    namespace math {
        struct MTX44;
    }
}
#endif

namespace mw { namespace nar
{
    struct Mtx33RF_st;
    /* Please see man pages for details 
     */
    class Transformation_cl
    {
    public:
#ifdef NAR_TWL__
        /* Please see man pages for details 
         */
        void GetMtxFx43( MtxFx43 & r_Mtx ) const;
#endif
#ifdef NAR_CTR__
        /* Please see man pages for details 
         */
        void GetMTX34( nn::math::MTX34 & r_Mtx ) const;
#endif

        //
        /* Please see man pages for details 
         */
        const Vec3F_st & GetrXAxis() const { return ma_Vec[ me_X ]; }
        
        /* Please see man pages for details 
         */
        const Vec3F_st & GetrYAxis() const { return ma_Vec[ me_Y ]; }
        
        /* Please see man pages for details 
         */
        const Vec3F_st & GetrZAxis() const { return ma_Vec[ me_Z ]; }
        
        /* Please see man pages for details 
         */
        const Vec3F_st & GetrTrans() const { return ma_Vec[ me_Trans ]; }

        /* Please see man pages for details 
         */
        void SetRot( const Vec3F_st & cr_X, const Vec3F_st & cr_Y, const Vec3F_st & cr_Z )
        {
            ma_Vec[ me_X ] = cr_X;
            ma_Vec[ me_Y ] = cr_Y;
            ma_Vec[ me_Z ] = cr_Z;
        }

        /* Please see man pages for details 
         */
        void SetTrans( const Vec3F_st & cr_Trans )
        {
            ma_Vec[ me_Trans ] = cr_Trans;
        }

        /* Please see man pages for details 
         */
        void TransformToRefPlane( Vec3F_st & r, const Vec3F_st & cr ) const;

        /* Please see man pages for details 
         */
        void Concatenate( Mtx33RF_st & r );
        //
    private:
        enum
        {
            me_X, me_Y, me_Z, me_Trans, me_Max
        };

        Vec3F_st    ma_Vec[ me_Max ];
    };
}
}

#endif
