/*-----------------------------------------------------------------------*
  Project:  Nintendo Augmented Reality Library.
  File:     sampledemos\marker_maker\narDemoConfig.h

  Copyright (C)2011-2012 Nintendo Co., Ltd.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensed developers
  and are protected by national and international copyright laws. They
  may not be disclosed to third parties or copied or duplicated in any
  form, in whole or in part, without the prior written consent of
  Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
*-----------------------------------------------------------------------*/

/**
 *  @file
 *  @author Satoru Osako
 */
#ifndef NAR_DEMO_CONFIG_H__
#define NAR_DEMO_CONFIG_H__

#if 1
# define CAMERA_WIDTH   (512)
# define CAMERA_HEIGHT  (384)

# define IMG_WIDTH      (512)
# define IMG_HEIGHT     (384)

# define TEXTURE_WIDTH  (512)
# define TEXTURE_HEIGHT (512)

# define CAMERA_SIZE    (nn::camera::SIZE_DS_LCDx4)
#else
# define CAMERA_WIDTH   (256)
# define CAMERA_HEIGHT  (192)

# define IMG_WIDTH      (256)
# define IMG_HEIGHT     (192)

# define TEXTURE_WIDTH  (256)
# define TEXTURE_HEIGHT (256)

# define CAMERA_SIZE    (nn::camera::SIZE_DS_LCD)
#endif
#define TOP_LCD_WIDTH   (400)
#define TOP_LCD_HEIGHT  (240)

#define YUV_BYTES       (2)
#define RGB_BYTES       (2)
#define IMG_PIXEL_NUM   (IMG_WIDTH * IMG_HEIGHT)
#define IMG_BYTES       (IMG_PIXEL_NUM * YUV_BYTES)
#define TEXTURE_BYTES   (TEXTURE_WIDTH * TEXTURE_HEIGHT * RGB_BYTES)

#endif

