/*-----------------------------------------------------------------------*
  Project:  Nintendo Augmented Reality Library.
  File:     sampledemos\common\narDemoCamera.h

  Copyright (C)2011-2012 Nintendo Co., Ltd.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensed developers
  and are protected by national and international copyright laws. They
  may not be disclosed to third parties or copied or duplicated in any
  form, in whole or in part, without the prior written consent of
  Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
*-----------------------------------------------------------------------*/

/* Please see man pages for details 
 
 
 */
#ifndef NAR_DEMO_CAMERA_H__
#define NAR_DEMO_CAMERA_H__

#include <nn.h>

class Y2RJob_cl;
//=====================================================================
/* Please see man pages for details 
 
 */
class CameraProcess_cl
{
public:
    CameraProcess_cl()
         : m_Capturing( 0 ), m_Captured( 0 ), m_Locked( 0 ), m_CapturedEvent( false )
    {}

    /* Please see man pages for details 
     
     */
    void    Initialize( nn::camera::Port port, u32 transLine, nn::fnd::ExpHeap * p_Heap );

    /* Please see man pages for details 
     */
    void    LockImage();

    void    StartThread();

    /* Please see man pages for details 
     */
    u16 *   GetpLockedYuv() { return maap_YuvBuffer + m_Locked * IMG_PIXEL_NUM; }

    nn::os::Event * GetpCapturedEvent() { return &m_CapturedEvent; }

    /* Please see man pages for details 
     */
    const nn::fnd::TimeSpan &   GetrShootingTimeOfLockedImage() { return ma_ShootingTime[ m_Locked ]; }

    /* Please see man pages for details 
     */
    const nn::fnd::TimeSpan &   GetrTransferTimeOfLockedImage() { return ma_TransferTime[ m_Locked ]; }

    /* Please see man pages for details 
     */
    void    Finalize();
private:
    enum
    {
        me_CameraTransferEvent,
        me_CameraErrorEvent,
        me_CameraEndEvent,
        me_CameraEventNum
    };

    enum
    {
        me_YuvBufferNum = 3
    };

    nn::camera::Port        m_Port;
    s8                      m_Capturing;
    s8                      m_Captured;
    s8                      m_Locked;

    nn::os::Event           ma_Events[ me_CameraEventNum ];
    nn::os::Event           m_CapturedEvent;
    nn::os::Thread          m_Thread;

    //  Use one big array for more efficient memory use
    u16 *                   maap_YuvBuffer;
    nn::os::CriticalSection m_CriticalSection;

    nn::fnd::ExpHeap *      mp_Heap;
    
    //  64 bit
    nn::fnd::TimeSpan       ma_ShootingTime[ me_YuvBufferNum ];
    nn::fnd::TimeSpan       ma_TransferTime[ me_YuvBufferNum ];
    
    static void hook( CameraProcess_cl * p )
    {
        p->process();
    }

    void    process();
    void    setReceiving();
};


#endif
