/*-----------------------------------------------------------------------*
  Project:  Nintendo Augmented Reality Library.
  File:     sampledemos\common\narDemoY2r.h

  Copyright (C)2011-2012 Nintendo Co., Ltd.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo and/or its licensed developers
  and are protected by national and international copyright laws. They
  may not be disclosed to third parties or copied or duplicated in any
  form, in whole or in part, without the prior written consent of
  Nintendo.
  The content herein is highly confidential and should be handled
  accordingly.
*-----------------------------------------------------------------------*/

/* Please see man pages for details 
 
 
 */
#ifndef NAR_DEMO_Y2R_H__
#define NAR_DEMO_Y2R_H__

//=====================================================================
/* Please see man pages for details 
 
 */
class Y2RJob_cl
{
friend class Y2RProcess_cl;
public:
    Y2RJob_cl()
         : mp_Next( 0 )
    {}

    void Set( void * p_Yuv, void * p_Rgb )
    {
        mp_Yuv  = p_Yuv;
        mp_Rgb  = p_Rgb;
    }

    void *  GetpYuv() { return mp_Yuv; }
    void *  GetpRgb() { return mp_Rgb; }

private:
    void *          mp_Yuv;
    void *          mp_Rgb;
    Y2RJob_cl *     mp_Next;
};
//=====================================================================
/* Please see man pages for details 
 
 */
class Y2RProcess_cl
{
public:
    Y2RProcess_cl()
         : mp_WorkingJob( 0 ), m_NewJobEvent( false ), m_TransEndEvent( false ), m_JobDoneEvent( false ), m_EndRequest( false )
    {
    }

    void    Initialize();

    /* Please see man pages for details 
     */
    void    Finalize();

    /* Please see man pages for details 
     */
    void    Push( Y2RJob_cl & r );

    /* Please see man pages for details 
     */
    bool    Start()
    {
        if ( mp_WorkingJob )
        {
            m_NewJobEvent.Signal();
            return true;
        }
        return false;
    }

    /* Please see man pages for details 
     */
    void    WaitJobFinish()
    {
        m_JobDoneEvent.Wait();
    }
    
    //  static singleton
    static  Y2RProcess_cl & ss()
    {
        static Y2RProcess_cl s_Instance;
        return s_Instance;
    }
private:
    Y2RJob_cl *         mp_WorkingJob;
    nn::os::LightEvent  m_NewJobEvent;
    nn::os::Event       m_TransEndEvent;
    nn::os::LightEvent  m_JobDoneEvent;
    nn::os::Thread      m_Thread;
    bool                m_EndRequest;
    u8                  a_pad[3];

    static void hook( Y2RProcess_cl * p_Y2r )
    {
        p_Y2r->process();
    }

    void    process();
};


#endif
