﻿/*---------------------------------------------------------------------------*
  Project:  Horizon

  Copyright (C)Nintendo Co., Ltd.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Rev: 58466 $
 *---------------------------------------------------------------------------*/

#ifndef NN_COMMON_SCENE_SCENEMANAGER_H_
#define NN_COMMON_SCENE_SCENEMANAGER_H_

#include "SceneFactory.h"
#include "Scene.h"
#include "Stack.h"

namespace scene
{

/* Please see man pages for details 
    

           
*/
class SceneManager
{
public:
    /* Please see man pages for details 
        
    */
    SceneManager();

    /* Please see man pages for details 
        
    */
    virtual ~SceneManager();

    /* Please see man pages for details 
        

        
        

        
    */
    bool Initialize(SceneFactory* pSceneFactory, s32 initialSceneId);

    /* Please see man pages for details 
        
    */
    void Finalize();

    /* Please see man pages for details 
        
    */
    void Update();

    /* Please see man pages for details 
        
    */
    void Draw();

    /* Please see man pages for details 
        

        
    */
    bool IsExpectedToFinish();

    /* Please see man pages for details 
        

        
    */
    bool IsRejectHome();

protected:
    // Scene factory
    SceneFactory* m_pSceneFactory;
    // Scene
    Scene* m_pScene;
    // Scene ID
    s32 m_sceneId;
    // Scene state
    s32 m_sceneState;

    // Scene stack
    Stack<s32, 16> m_sceneStack;
};

} // namespace scene

#endif // NN_COMMON_SCENE_SCENEMANAGER_H_
